/****************************************************************************
*
*    Copyright (c) 2020 Vivante Corporation
*
*    Permission is hereby granted, free of charge, to any person obtaining a
*    copy of this software and associated documentation files (the "Software"),
*    to deal in the Software without restriction, including without limitation
*    the rights to use, copy, modify, merge, publish, distribute, sublicense,
*    and/or sell copies of the Software, and to permit persons to whom the
*    Software is furnished to do so, subject to the following conditions:
*
*    The above copyright notice and this permission notice shall be included in
*    all copies or substantial portions of the Software.
*
*    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
*    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
*    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
*    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
*    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
*    FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
*    DEALINGS IN THE SOFTWARE.
*
*****************************************************************************/

#ifndef __ANEURALNETWORKS_BOX_WITH_NMS_LIMIT_HPP__
#define __ANEURALNETWORKS_BOX_WITH_NMS_LIMIT_HPP__

#define OP_SPEC_NAME BoxWithNmsLimitOperation
OP_SPEC_BEGIN()
#define ARG_NAMES         \
    (box_score,                 \
     boxes,           \
     batch_index,   \
     score_threshold, \
     max_boxes,   \
     nms_kernel_method, \
     iou_threshold, \
     nms_sigma, \
     nms_score_threshold)
#define ARGC BOOST_PP_TUPLE_SIZE(ARG_NAMES)

#define BOOST_PP_LOCAL_MACRO(n) OP_SPEC_ARG(BOOST_PP_TUPLE_ELEM(ARGC, n, ARG_NAMES))
#define BOOST_PP_LOCAL_LIMITS (0, ARGC)
#include BOOST_PP_LOCAL_ITERATE()
OP_SPEC_END()

// order of argument is important
MAKE_SPEC(box_with_nms_limit_operation)
    .box_score_(nnrt::OperandType::TENSOR_FLOAT32)
    .boxes_(nnrt::OperandType::TENSOR_FLOAT32)
    .batch_index_(nnrt::OperandType::TENSOR_INT32)
    .score_threshold_(nnrt::OperandType::FLOAT32)
    .max_boxes_(nnrt::OperandType::INT32)
    .nms_kernel_method_(nnrt::OperandType::INT32)
    .iou_threshold_(nnrt::OperandType::FLOAT32)
    .nms_sigma_(nnrt::OperandType::FLOAT32)
    .nms_score_threshold_(nnrt::OperandType::FLOAT32));

    OVERRIDE_SPEC(box_with_nms_limit_operation, float16)
    .box_score_(nnrt::OperandType::TENSOR_FLOAT16)
    .boxes_(nnrt::OperandType::TENSOR_FLOAT16));

    OVERRIDE_SPEC(box_with_nms_limit_operation, quant8_asymm)
    .box_score_(nnrt::OperandType::TENSOR_QUANT8_ASYMM)
    .boxes_(nnrt::OperandType::TENSOR_QUANT16_ASYMM));

#undef ARG_NAMES
#undef ARGC
#undef OP_SPEC_NAME

#endif
